import random
from ipc.downloader.geo_microarray.gpl_auto_annotation import ontology_functions
from ipc.downloader.geo_microarray.gpl_auto_annotation import ontology_mapper

def check_dict(data,dic):
    col_idx=0
    for col in list(data.columns):
        if col in dic:
            lst= dic[col]
            for func in lst: 
                row_idx=0 
                while(data.iloc[row_idx,col_idx]==None):
                    row_idx=random.randint(0,data.shape[0]-1)  
                if func(data.iloc[row_idx,col_idx]) == True:
                    return [func,col_idx]
        col_idx+=1
    return False



def check_func(row,lst):
    n=len(row)
    for func in lst:
        for col_idx in range(1,n): 
            if func(row[col_idx]) == True:
                return [func,col_idx]
    return False

def gpl_annotation(table):
    mapper= ontology_mapper.init_mapper()
    function_list=[ontology_functions.is_symbol,ontology_functions.is_ensembl,ontology_functions.is_gene_ass,ontology_functions.is_genbank,ontology_functions.is_genbank_gblist,ontology_functions.is_assoc_gene]
    cols=list(table.columns)
    res=check_dict(table,mapper)
    if res==False:
        row_idx=random.randint(0,table.shape[0]-1)  
        row=list(table.iloc[row_idx,:])
        res=check_func(row, function_list)
        if res==False:
            tries=0
            while res==False and tries<10:
                row_idx=random.randint(0,table.shape[0]-1)  
                row=list(table.iloc[row_idx,:])
                res=check_func(row, function_list)
                tries+=1
        if res==False:
            return ["False","False"]
        elif res !=False:
            ontology_mapper.add_to(mapper,cols[res[1]],res[0])
            return [cols[res[1]],ontology_mapper.rev_map(res[0])]
    else:
        return [cols[res[1]],ontology_mapper.rev_map(res[0])]